﻿using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;
using System.IO;
using System.Threading;

namespace WindowsService
{
    public partial class MyNewService : ServiceBase
    {
		private System.Diagnostics.EventLog eventLog1;
		/// <summary> 
		/// 필수 디자이너 변수입니다.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Timers.Timer tmJobTimer = null;
		private Timer _timer;

        public MyNewService()
		{
			// 이 호출은 Windows.Forms 구성 요소 디자이너에 필요합니다.
			InitializeComponent();

			if (!System.Diagnostics.EventLog.SourceExists("MySource")) 
			{         
				System.Diagnostics.EventLog.CreateEventSource("MySource","MyNewLog");
			}
			eventLog1.Source = "MySource";
			eventLog1.Log = "MyNewLog";
		}

		// 프로세스의 주 진입점입니다.
		static void Main()
		{
			System.ServiceProcess.ServiceBase[] ServicesToRun;
			// Change the following line to match.
			ServicesToRun = new System.ServiceProcess.ServiceBase[] { new MyNewService() };
			System.ServiceProcess.ServiceBase.Run(ServicesToRun);
		}

		/// <summary> 
		/// 디자이너 지원에 필요한 메서드입니다. 
		/// 이 메서드의 내용을 코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{
			this.eventLog1 = new System.Diagnostics.EventLog();
			((System.ComponentModel.ISupportInitialize)(this.eventLog1)).BeginInit();
			// 
			// Service1
			// 
			this.ServiceName = "MyNewService";
			((System.ComponentModel.ISupportInitialize)(this.eventLog1)).EndInit();

		}

		/// <summary>
		/// 사용 중인 모든 리소스를 정리합니다.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// 서비스가 작업을 수행할 수 있도록 필요한 동작을 설정합니다.
		/// </summary>
		protected override void OnStart(string[] args)
		{
			/*
			FileStream fs = new FileStream(@"c:\temp\mcWindowsService.txt" , 
			FileMode.OpenOrCreate, FileAccess.Write); 
			StreamWriter m_streamWriter = new StreamWriter(fs); 
			m_streamWriter.BaseStream.Seek(0, SeekOrigin.End); 
			m_streamWriter.WriteLine(" mcWindowsService: Service Started \n"); 
			m_streamWriter.Flush();
			m_streamWriter.Close();
			*/

			//eventLog1.WriteEntry("In OnStart");

			//this.tmJobTimer = new System.Timers.Timer();
			//this.tmJobTimer.Enabled = true;  
			//this.tmJobTimer.Interval = 5000;

			//this.tmJobTimer.Elapsed += new System.Timers.ElapsedEventHandler(this.tmJobTimer_Elapsed);
			/*
			 서비스 어플리케이션의 시작 method입니다. 지속적으로 수행되는 어플리케이션의 경우에는 별도의 thread를 생성하는 편이 좋다.
			 즉, method는 가능한 빨리 완료되는 것이 좋다.
			*/

			Thread TestThread = new Thread(new ThreadStart(tmJobTimer_Elapsed));
			TestThread.Start();

            //eventLog1.WriteEntry("시작");
		}

		private void tmJobTimer_Elapsed()
		{
            // 맨 마지막 파라미터값은 얼마간격으로 할껀지이다.
            //new Timer(new TimerCallback(Timer), null, 0, 10000);

            // 매일 16:30분에 스케줄 돌아감....^^ 즉 원하는 시간을 셋팅하면 됨. ㅎㅎ
            TimeSpan Now = new TimeSpan(DateTime.Now.Hour, DateTime.Now.Minute, DateTime.Now.Second);
            TimeSpan DueTime = new TimeSpan(16, 30, 0); // 원하는 시간을 셋팅 함.(시, 분 초)
            TimeSpan result = DueTime - Now;

            new Timer(new TimerCallback(Timer), null, Convert.ToInt32(result.TotalMilliseconds), 86400000);
		}

		public void SetTime(TimeSpan _time)   
		{   
			if (this._timer != null)   
			{  
				this._timer.Dispose();   
			}

            DateTime ccc = DateTime.Now;
            TimeSpan Now = new TimeSpan(ccc.Hour, ccc.Minute, ccc.Second);
			TimeSpan DueTime = GetDueTime(Now, _time);
 
			this._timer = new Timer(new TimerCallback(Timer), null, DueTime, new TimeSpan(24, 0, 0));  
		}

		public static TimeSpan GetDueTime(TimeSpan A, TimeSpan B)   
		{   
			if (A < B)   
			{   
				return B.Subtract(A);   
			}   
			else  
			{   
				return new TimeSpan(24, 0, 0).Subtract(B.Subtract(A));   
			}   
		}

		public void Timer(Object stateInfo)
		{
            eventLog1.WriteEntry("이벤트 로그발생1");
		}

        public void Timer()
        {
            eventLog1.WriteEntry("이벤트 로그발생2");
        }

		private void DoJob()
		{
			//eventLog1.WriteEntry("aaaaa");
		}
 
		/// <summary>
		/// 이 서비스를 중지합니다.
		/// </summary>
		protected override void OnStop()
		{
			/*
			FileStream fs = new FileStream(@"c:\temp\mcWindowsService.txt" , 
			FileMode.OpenOrCreate, FileAccess.Write); 
			StreamWriter m_streamWriter = new StreamWriter(fs); 
			m_streamWriter.BaseStream.Seek(0, SeekOrigin.End); 
			m_streamWriter.WriteLine(" mcWindowsService: Service Stopped \n"); m_streamWriter.Flush();
			m_streamWriter.Close();
			*/

			//eventLog1.WriteEntry("In onStop.");

            eventLog1.WriteEntry("종료");

			if (this.tmJobTimer != null)  
			{    
				this.tmJobTimer.Enabled = false;    
				this.tmJobTimer.Close();    
				this.tmJobTimer.Dispose();    
				this.tmJobTimer = null;   
			}
		}
    }
}
